﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@
'WebSocket class
Sub Class_Globals
	Private ws As WebSocket
	Private scriptName, MainDiv, MainPanel, GoBack, GoNext, Structure, MyLogo, MyAudio, MyVideo As JQueryElement
	Private MyData, MyDict, DoCopy1, DoCopy2, Progress1, Progress2, BtnSearch As JQueryElement
	Private thisScriptName As String
	Private parser As JSONParser
	Private scriptSequence As List
	Private qpars() As  String
	Private screenWidth, screenHeight, panelWidth, panelLeft, panelHeight, panelTop, butTop As Int
	Private myPnl As myPanel
	Private searchChoice, structureContents, structureStyle, searchResult, logAnswers, history, progressBar, slideScheduler As List
	Private root, dataMap, crossRef, isShowable As Map
	Private firstTextInput As Boolean
	Private currentBlock As Int = -1
	Private MaxN As Int = -1
	Public aspectRatio As Float = 1.0
	Public fontTypeFace As String = "Century Gothic"
	Public headerFontColor As String = "Black"
	Public elementFontColor As String = "Blue"
	Public screenColor As String = "LightBlue"
	Public panelColor As String = "LightGray"
	Public administrator As String = "~none~"
	Public login As String = "none"
	Public record As String = "no"
	Public forceAnswers As List
	Public tobeAnswered As Int = 0
	Private progressPercent As Float
	Private progressStart As Int = -1
	Private progressEnd As Int = -1
	Private audioPlaying As Boolean = False
	Private videoPlaying As Boolean = False
	Private slideTimer As Timer
	Public screenResizeTimer As Timer
	Private slideStart, fadeTimer As Long
	Public SQL1 As SQL
	Type QSRecord (SeqNum As String, User As String, PW As String, Session As Long, TypeUser As String, Complete As String, _
		 Alias As String, StartDate As String, EndDate As String, PartialContent As String)
	Private QSR As QSRecord
	Private ser As B4XSerializator
	Private su As StringUtils
	Public HashPassword As BCrypt
	Public HashedPassword As String
	Public isAdministrator As Boolean = False
	Public isDebug As Boolean = False
	Private SecureRandom1 As SecureRandom
	Private tempName As String
End Sub

Public Sub Initialize
	DateTime.DateFormat = "yyyy-MM-dd hh:mm a"
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	ws = WebSocket1
	'ws.Eval($"alert("Socket connected")"$, Null)
	Log("ws connected")

	Dim qpar As Future = ws.RunFunctionWithResult("getQString", Null)
	qpars = twoParts(qpar.Value, "_")
	thisScriptName = qpars(0)
	If qpars(1).StartsWith("admin") Then isAdministrator = True
	If qpars(1).StartsWith("debug") Then isDebug = True
	Dim projectFolder As String = File.DirApp & "/QSScripts/" & thisScriptName

	isDebug = True

	scriptUtils.recreateJson(thisScriptName, isDebug)
	parser.Initialize(File.ReadString("QSScripts/" & thisScriptName, thisScriptName & ".json"))
	Dim root As Map = parser.NextObject
	scriptSequence = root.Get("sequence")

	QSR.Initialize
	QSR.Session = 0
	QSR.User = "anon"
	QSR.PW = ""
	QSR.TypeUser = "client"
	QSR.Session = 1
	QSR.Complete = "NO"
	QSR.Alias = ""
	QSR.StartDate = DateTime.Date(DateTime.Now)
	QSR.EndDate = DateTime.Date(DateTime.Now)
	If isAdministrator Then QSR.TypeUser = "administrator"

	isShowable = scriptUtils.defineShowable
	crossRef.initialize: defineCrossRef
	forceAnswers.Initialize
	progressBar.Initialize
	setScriptOptions
	If isDebug Then 
		record = "yes"
		administrator = "*QS="
	End If
	
	If record = "yes" Then
		SQL1.InitializeSQLite(projectFolder, "db.db", True)
		CreateTable
	End If
	
	screenWidth = MainDiv.GetWidth.value
	screenHeight = MainDiv.GetHeight.value
	screenResizeTimer.Initialize("screenResizeTimer", 500)
	screenResizeTimer.Enabled = True
	setupMainPanel
	
	dataMap.initialize
	logAnswers.initialize
	searchResult.initialize
	searchChoice.initialize
	
	slideScheduler.initialize
	slideTimer.Initialize("slideTimer", 250)
	slideTimer.enabled = False
	history.initialize
	audioPlaying = False
	videoPlaying = False
	moveToNextBlock
End Sub

Sub MainDiv_Click (Params As Map)
	fadeTimer = DateTime.now
	Dim  target As String = Params.Get("target")
	If target="gonext" Then
		If isAdministrator Then resetAdmin
		If audioPlaying Then disableAudio
		If videoPlaying Then disableVideo
		recordAnswers
		Dim currentBlk As Map = scriptSequence.Get(currentBlock)
		Dim bname As String = currentBlk.Get("name")
		If tobeAnswered>0 And forceAnswers.indexOf(bname)>-1 Then 
			ws.RunFunction("showMessage", Array As String("An answer is needed in order to proceed"))
			showScreen
		Else
			moveToNextBlock
		End If
	Else If target="goback" Then
		If audioPlaying Then disableAudio
		If videoPlaying Then disableVideo
		GoNext.SetCSS("visibility", "visible")
		moveToPreviousShown
	Else if target.StartsWith("btnsearch") Then
		structureContents.set(1, customSearchB4X(target))
		structureStyle.set(1, "")
		upDateMainPanel
	Else if target.StartsWith("admingo") Then
		adminAfterFirstScreen
	Else if target.StartsWith("adminzdel") Then
		Dim jqx  As JQueryElement = ws.GetElementById("adminlstz")
		Dim answerx As Future = jqx.GetVal
		Dim choice As String = answerx.value
		Dim wd As Map: wd.Initialize
		wd.Put("SeqNum", choice)
		DBUtils.DeleteRecord(SQL1, "QS", wd )
		moveToNextBlock
	Else if target.StartsWith("adminzrev") Then
		adminReviewScreen
	Else if target.StartsWith("btngo") Then
		goCustomSearch
	Else if target<>"" And target.StartsWith("div") = False Then
		logAnswers.add(target)
	End If
End Sub

Sub moveToNextBlock
	ws.flush
	Dim thisBlk As Map
	If currentBlock>-1 Then
		thisBlk = scriptSequence.Get(currentBlock)
		elementACTIONs(thisBlk)
		headACTIONs(thisBlk)
	End If
	
	Dim saveC As Int = currentBlock
	currentBlock = currentBlock + 1
	Do While currentBlock < scriptSequence.Size
		saveC = currentBlock
		thisBlk = scriptSequence.Get(currentBlock)
		If thisBlk.containsKey("name") Then
			Dim valid As Boolean = True
			If thisBlk.ContainsKey("condition") Then
				valid = testCondition(thisBlk.Get("condition"))
			End If
			'Log("Looking at: " & thisBlk.get("name") & " " & valid & " " & blockShown(thisBlk))
			If valid And isBlockShown(thisBlk) Then
				showScreen
				Return
			Else if valid Then
				elementACTIONs(thisBlk)
				headACTIONs(thisBlk)
			End If
		End If
		currentBlock = currentBlock + 1
	Loop
	If currentBlock = saveC + 1 Then GoNext.SetCSS("visibility", "hidden")
End Sub

Sub showScreen
	Select history.Size
		Case 0: GoBack.SetCSS("visibility", "hidden")
		Case 1: GoBack.SetCSS("visibility", "visible")
	End Select
	If isAdministrator Then GoBack.SetCSS("visibility", "hidden")
	
	If currentBlock = scriptSequence.Size - 1 Then GoNext.SetCSS("visibility", "hidden")
	
	Dim nextBlk As Map = scriptSequence.Get(currentBlock)
	Dim blkName As String = nextBlk.Get("name")
	'Log("Showing: " & blkName)
	history.add (blkName)
	resetLists
		
	Dim header As String = ""
	If nextBlk.ContainsKey("content") Then header = expandBackRef(nextBlk.Get("content"))
	If header.IndexOf("[")>-1 Then		'smaller font italic footnote to header
		Dim k As Int = header.IndexOf("[")
		Dim st As String = $"font-size: ${hPX(8)}; font-weight: normal; font-style: italic; color: green;"$
		header = $"${header.SubString2 (0,k)}<center><p style="${st}">${header.SubString2 (k,header.Length)}</p><center>"$
	End If
	
	Dim style As String = deriveStyle(nextBlk, 12, "bold", headerFontColor, "")
	Dim place As Int = fromPosition(nextBlk, 0)
	If place>9999 Then 
		header = "<center>" & header & "</center>"
		place = place - 10000
	End If
	structureContents.set(place, header)
	structureStyle.set(place, style)
	
	Dim hspec As String = ""
	If nextBlk.ContainsKey("specifier") Then hspec = nextBlk.Get("specifier")
	If hspec.StartsWith("SLIDESHOW") Then startAudio(hspec)
	If hspec.StartsWith("MOVIE") Then startVideo(hspec)
	
	firstTextInput = False		'need this to set focus to first key input field
	
	Dim elements As List = nextBlk.Get("elements")
	Dim n As Int = elements.Size-1
	If n>14 Then n = 14
	MaxN = place
	tobeAnswered = 0

	For j = 0 To n
		Dim item As Map = elements.Get(j)
		Dim valid As Boolean = True
		If item.ContainsKey("condition") Then valid = testCondition(item.Get("condition"))

		If valid = True Then
			Dim ref As String = blkName & "#" & j
			Dim oldData As String = ""
			If dataMap.ContainsKey(ref) Then oldData = dataMap.Get(ref)
			Dim spec As String = ""
			If item.ContainsKey("specifier") Then spec = item.Get("specifier")
			Dim specifier() As String = twoParts(spec, " ")
			If isShowable.get(specifier(0)) = True Then
				renderItem(item, specifier, oldData, place, j)
			Else if spec.startsWith ("LOGO") Then
				placeIt (MyLogo, CreateMap("top": xPX(panelHeight/30), "left": xPX((screenWidth - panelWidth)/2 - screenWidth/10)))
				sizeIt (MyLogo, CreateMap("width": xPX(screenWidth/15), "height": xPX(screenWidth/15)))
				MyLogo.SetCSS("visibility", "visible")
			End If
		End If
	Next
	upDateMainPanel
End Sub

Sub upDateMainPanel()
	Dim sb As StringBuilder: sb.initialize
	For i = 0 To MaxN
		Dim idx As String = "x"
		If i>0 Then idx = i - 1
		Dim content As String = structureContents.Get(i)
		Dim style As String = structureStyle.Get(i)
		Dim r As String = $"<div id="item${idx}" ${style}>${content}</div>"$
		sb.append (r)
	Next
	
	Dim duration As Long = DateTime.Now - fadeTimer
	Do While duration < 350
		Sleep(50)
		duration  = DateTime.Now - fadeTimer
	Loop
	MainPanel.SetHtml (sb.ToString)
	
	If progressEnd>-1 And currentBlock >= progressStart And currentBlock <= progressEnd Then
		progressPercent = 100*(currentBlock-progressStart)/(progressEnd-progressStart)
	
		placeIt (Progress1, CreateMap("top": xPX(panelTop+1.05*panelHeight), "left": xPX(panelLeft+.025*panelWidth)))
		sizeIt (Progress1, CreateMap("height": xPX(.01*panelHeight), "width": xPX(panelWidth)))
		styleIt (Progress1, CreateMap("border": "1px solid black", "visibility": "visible", "z-index": "1001", "background-color": "#BDABAB"))

		placeIt (Progress2, CreateMap("top": xPX(panelTop+1.05*panelHeight), "left": xPX(panelLeft+.025*panelWidth)))
		sizeIt (Progress2, CreateMap("height": xPX(.01*panelHeight), "width": xPX((progressPercent /100) * panelWidth)))
		styleIt (Progress2, CreateMap("border": "1px solid black", "visibility": "visible", "z-index": "1001", "background-color": "Green"))
	Else
		Progress1.SetCSS("visibility", "hidden")
		Progress2.SetCSS("visibility", "hidden")
	End If
	ws.Eval("$('#mainpanel').fadeIn();", Null)
End Sub

Sub elementACTIONs(thisBlk As Map)
	Dim elements As List = thisBlk.Get("elements")
	For Each item As Map In elements
		Dim valid As Boolean = True
		If item.ContainsKey("condition") Then valid = testCondition(item.Get("condition"))

		If valid Then
			If item.containsKey("actions") Then
				Dim acts As List = item.Get("actions")
				For Each a As String In acts
					If a.StartsWith("GOTO") Then
						currentBlock = crossRef.Get(a.SubString(5)) - 1
						Return
					else if a.StartsWith("BACKTO") Then
						Dim target As String = a.SubString(7).trim
						Dim k As Int = history.IndexOf(target)
						If k>-1 Then
							For i = history.Size-1 To k Step -1
								history.RemoveAt(i)
							Next
						End If
						currentBlock = crossRef.Get(target) - 1
						Return
					else if a.StartsWith("SET") Then
						Dim r() As String = twoParts(a.SubString(4), ",")
						If r(1) = "blank" Then r(1) = ""
						If crossRef.ContainsKey(r(0)) Then
							Dim x As Object = crossRef.Get(r(0))
							If IsNumber(x) Then r(0) = twoParts (r(0), "#")(0) & "#" & x
						End If
						dataMap.put(r(0), r(1))
					else if a.StartsWith("REMOVE") Then
						Dim rx As String = a.SubString(7)
						If rx="history" Then 
							history.initialize
						Else
							If crossRef.ContainsKey(rx) Then
								Dim x As Object = crossRef.Get(rx)
								If IsNumber(x) Then rx = twoParts (rx, "#")(0) & "#" & x
							End If
							dataMap.Remove(rx)
						End If
					else if a.StartsWith("REGISTER") Or a.StartsWith("VERIFY") Then
						authetication(a, thisBlk)
					else if a.StartsWith("REINSTATE") Then
						If QSR.PartialContent<>Null Then
							Dim bytes() As Byte = su.DecodeBase64(QSR.PartialContent)
							dataMap  = ser.ConvertBytesToObject(bytes)
							dataMap.Put("INCOMPLETE#0", 0)
						End If
						Dim wd As Map: wd.Initialize
						wd.Put("SeqNum", QSR.SeqNum)
						DBUtils.DeleteRecord(SQL1, "QS", wd )
					else if a.StartsWith("RESTORE") Then
						Dim pars() As String = twoParts(a," ")
						If pars(1) = "history" Then
							history = dataMap.Get("history")
							currentBlock = crossRef.Get(history.Get(history.Size-1)) - 1
							history.RemoveAt(history.Size-1)
						End If
					else if a.StartsWith("DELETELAST") Then
						Dim wd As Map: wd.Initialize
						wd.Put("SeqNum", QSR.SeqNum)
						DBUtils.DeleteRecord(SQL1, "QS", wd )
					else if a.StartsWith("CLOSESESSION") Then
						GoNext.SetCSS("visibility", "hidden")
						If QSR.Complete = "NO" And record = "yes" Then
							dataMap.Remove("history")
							QSR.Complete = "YES"
							Log("Session closed")
							addNewRecord
						End If
					else if a.StartsWith("ALIAS") Then
						Dim pars() As String = twoParts(a," ")
						Dim el() As String = twoParts(pars(1), ",")
						Dim userResult As String = fromCrossRef(el(0))
						QSR.Alias = userResult
					Else
						Log("Unknown action: " & a)
					End If
				Next
			End If
		End If
	Next
End Sub

Sub fromCrossRef(x As String) As String
	Dim xx() As String = twoParts(x, "#")
	Return dataMap.Get(xx(0) & "#" & crossRef.get(x))
End Sub

Sub headACTIONs(thisBlk As Map)
	If thisBlk.containsKey("actions") Then
		Dim acts As List = thisBlk.Get("actions")
		For i = 0 To acts.size-1
			Dim a As String = acts.Get(i)
			If a.StartsWith("NEXTTO") Then
				currentBlock = crossRef.Get(a.SubString(7)) - 1
				Return
			End If
		Next
	End If
End Sub

Sub setupMainPanel()
	If screenWidth<screenHeight Then
		panelWidth = screenWidth-3
		panelHeight= panelWidth/aspectRatio
		panelLeft = 0
		panelTop = screenHeight/2-panelHeight/2
		butTop = screenHeight - .08*panelHeight
	Else
		panelHeight = screenHeight-3
		panelWidth = aspectRatio*panelHeight
		panelLeft = screenWidth/2-panelWidth/2
		panelTop = 0
		butTop = panelTop + panelHeight/2 - .08*panelHeight
	End If
	
	myPnl.Left = panelLeft
	myPnl.Top = panelTop
	myPnl.Width = panelWidth
	myPnl.Height =panelHeight
	
	styleIt (MainDiv, CreateMap("background-color": screenColor, "user-select": "none"))
	MainDiv.SetHtml (makeIt("div", "GoBack") & makeIt("div", "MainPanel") & makeIt("div", "goNext"))

	GoBack.SetHtml ("&#10216")
	placeIt (GoBack, CreateMap("top": xPX(butTop), "left": "1px" ))
	sizeIt (GoBack, CreateMap("width": xPX(.0175*panelHeight), "height": xPX(.0175*panelHeight)))
	styleIt (GoBack, CreateMap("font-size": hPX(25), "visibility": "hidden", "z-index": "1001", "line-height": "0%"))

	placeIt (MainPanel, CreateMap("top": xPX(panelTop), "left": xPX(panelLeft)))
	sizeIt (MainPanel, CreateMap("width": xPX(panelWidth), "height": xPX(panelHeight)))
	styleIt (MainPanel, CreateMap("background-color": panelColor, "font-family": fontTypeFace))
	
	GoNext.SetHtml ("&#10217")
	placeIt (GoNext, CreateMap("top": xPX(butTop), "left": xPX(screenWidth - .08*panelHeight)))
	sizeIt (GoNext, CreateMap("width": xPX(.0175*panelHeight), "height": xPX(.0175*panelHeight)))
	styleIt (GoNext, CreateMap("font-size": hPX(25), "line-height": "0%"))
	
	structureContents.Initialize
	structureStyle.Initialize
End Sub

Sub isBlockShown (a As Map) As Boolean
	Dim elements As List = a.Get("elements")
	If a.containsKey("name") = False Then Return False
	If a.ContainsKey("content") Then Return True
	If a.ContainsKey("specifier") Then 
		If a.Get("specifier") <> "ACTIONONLY" Then 
			Return True
		End If
	End If
	For Each item As Map In elements
		Dim spec As String = ""
		If item.ContainsKey("specifier") Then 
			spec = item.Get("specifier")
		Else If item.ContainsKey("content") = False Then
			spec = "ACTIONONLY"	
		End If
		
		Dim specifier() As String = twoParts(spec, " ")
		If isShowable.get(specifier(0)) = True Then Return True
	Next
	Return False
End Sub

Sub fromPosition(m As Map, place As Int) As Int
	If m.ContainsKey("position") Then
		Dim pos As String = m.Get("position")
		Dim p() As String = Regex.Split(",", pos)
		If p.Length>1 Then
			If p(1) = "bottom" Then place = 14
			If p(1) = "center" Then place = 7
			If p(0) = "center" Then place = place + 10000
		End If
	End If
	Return place
End Sub

Sub defineCrossRef
	For i = 0 To scriptSequence.Size-1
		Dim m As Map = scriptSequence.Get(i)
		If m.ContainsKey("name") Then
			Dim blkName As String = m.Get("name")
			crossRef.Put(blkName, i)
		
		
			Dim el As List = m.get("elements")
			For j = 0 To el.Size-1
				Dim item As Map = el.Get(j)
				If item.ContainsKey("specifier") Then
					Dim spec As String = item.Get("specifier")
					Dim specifier() As String = twoParts(spec, " ")
					Dim pars As String = specifier(1).trim
					If spec.StartsWith("OPTIONS") Or spec.StartsWith("SCALE") Then
						If j>0 And (spec="OPTIONS" Or spec="SCALE") Then
							Dim prevItem As Map = el.Get(j-1)
							spec = prevItem.Get("specifier")
							item.Put("specifier", spec)
						End If
						Dim opts() As String = Regex.Split("\|", pars)
						crossRef.Put(blkName & "#" & j, opts)
						If item.ContainsKey("name") Then
							Dim itemName As String = item.Get("name")
							crossRef.Put(blkName & "#" & itemName, opts)
						End If
					End If
				End If
				If item.ContainsKey("name") Then
					Dim itemName As String = item.Get("name")
					crossRef.Put(blkName & "#" & itemName,  "" & j)
				End If
			Next
		else If m.ContainsKey("OPTIONS") Then 
			crossRef.Put("OPTIONS", i)
		End If
		
	Next
End Sub

Sub expandBackRef(s As String) As String
	Dim parts() As String = Regex.Split("@", s)
	Dim sb As StringBuilder: sb.initialize
	sb.Append(parts(0))
	For j = 1 To parts.Length-1
		Dim p As String = parts(j)
		Dim delim As String = $" ,.:?!|()[]<>\"\'_-"$
		Dim firstdelim As Int = p.Length
		For k = 0 To p.Length-1
			Dim c As Char = p.CharAt(k)
			If delim.IndexOf(c)>-1 Then
				firstdelim = k
				Exit
			End If
		Next
		Dim xref As String = p.SubString2 (0, firstdelim)
		If xref.IndexOf("#") = -1 Then xref = xref & "#0"
		If crossRef.ContainsKey(xref) Then
			If IsNumber(crossRef.Get(xref)) Then
				xref = xref.SubString2 (0, xref.IndexOf("#")+1) & crossRef.Get(xref)
			End If
		End If
		If dataMap.ContainsKey(xref) Then
			Dim d As String  = dataMap.Get(xref)
			If crossRef.ContainsKey(xref) Then
				Dim a() As String = crossRef.Get(xref)
				xref = a(d)
			Else
				xref = d
			End If
		End If
		sb.Append(xref & p.SubString(firstdelim))
	Next
	Return sb.tostring
End Sub

Sub testCondition(cond As String) As Boolean
	If cond.Length=0 Then Return True
	Dim orCombine As List: orCombine.initialize
	Dim v() As String = Regex.Split("\|", cond)
	Dim orTrue As Boolean = False
	For Each s As String In v
		s = s.trim
		Dim w() As String = Regex.Split("&", s)
		Dim andTrue As Boolean = True
		For Each t As String In w
			t = t.trim
			If testTruth(t) = False Then
				andTrue = False
				Exit
			End If
		Next
		If andTrue = True Then
			orTrue = True
			Exit
		End If
	Next
	Return orTrue
End Sub

Sub testTruth(t As String) As Boolean
	Log(QSR.TypeUser & " " & login)
	If t = "typeuser=administrator" Then Return QSR.TypeUser = "administrator"
	If t = "~typeuser=administrator" Then Return QSR.TypeUser <> "administrator"
	If t = "login=administrator" Then Return login = "administrator"
	If t = "~login=administrator" Then Return login <> "administrator"
	If t = "login=none" Then Return login = "none"
	
	Dim result As Boolean = False
	If t.IndexOf("=") = -1 Then t = t & "=*"
	Dim v() As String = Regex.Split("=", t)
	Dim negate As Boolean = False
	If v(0).EndsWith("~") Then 
		negate = True
		v(0) = v(0).SubString2(0, v(0).Length-1)
		Log(v(0) & " " & t)
	End If
	If v(0).StartsWith("~") Then
		negate = True
		v(0) = v(0).SubString(1)
	End If
	Dim ref As String = v(0)
	
	If crossRef.ContainsKey(ref) Then
		Dim x As Object = crossRef.Get(ref)
		If IsNumber(x) Then 
			ref = twoParts (ref, "#")(0) & "#" & x
		End If
	End If
	

	If dataMap.ContainsKey(ref) Then
		Dim d As String  = dataMap.Get(ref)
		If v.Length>2 Then
			result = (d = v(2))
		Else
			If crossRef.ContainsKey(ref) And v(1)<>"*" Then
				Dim a() As String = crossRef.Get(ref)
				result = (a(d) = v(1)) 
			Else if v(1) = "*" Then
				result = d.Length>0
			Else
				result = (d = v(1))
			End If
		End If
		If negate Then result = Not (result)
	Else
		If v(1) = "UNANSWERED" Then 
			result = negate = False
		End If
	End If
	Return result
End Sub

Sub moveToPreviousShown
	ws.flush
	If history.Size>1 Then
		history.RemoveAt(history.Size-1)
		Dim prev As String = history.Get(history.Size-1)
		history.RemoveAt(history.Size-1)
		currentBlock = crossRef.get(prev)
		showScreen
	End If
End Sub

Sub twoParts(s As String, c As String) As String()
	Dim r(2) As String
	r(0) = s
	r(1) = ""
	Dim k As Int = s.indexOf(c)
	If k>-1 Then
		r(0) = s.SubString2(0, k)
		r(1) = s.SubString(k+1)
	End If
	Return r
End Sub

Sub deriveStyle(m As Map, fs As Int, weight As String, color As String, hide As String) As String
	Dim emphX As String = weight
	Dim italX As String = "normal"
	Dim colX As String = color
	Dim fsizeX As Int = fs
	If m.ContainsKey("style") Then
		Dim stX As String = m.Get("style")
		Dim v() As String = Regex.Split(",", stX)
		For Each s As String In v
			If IsNumber(s) Then
				fsizeX = s
			else If s = "bold" Then
				emphX = s
			else If s = "italic" Then
				italX = s
			Else
				colX = s.toLowercase
			End If
		Next
	End If
	If hide<>"" Then 
		hide = " visibility: hidden;"
	End If
	Return  $"style="font-size: ${hPX(fsizeX)}; font-weight: ${emphX}; font-style: ${italX}; color: ${colX};${hide}""$
End Sub

Sub makeListFrom(x As String) As List
	Dim result As List: result.initialize
	x = x.Trim
	If x.Length>2 Then
		x = x.SubString2(1, x.length-1)
		result = Regex.Split(",", x)
		For Each t As String In result
			t = t.trim
		Next
	End If
	Return result
End Sub

Sub setScriptOptions()
	Dim defNum As Int = crossRef.get("OPTIONS")
	Dim first As Map = scriptSequence.Get(defNum)
	Dim QSOptions As List = first.get("elements")
	For Each attrMap As Map In QSOptions
		Dim what As String = attrMap.GetKeyAt(0)
		Dim valx As String = attrMap.Get(what)
		Select Case what
			Case "aspectRatio"
				Dim v() As String = twoParts(valx,":")
				aspectRatio = v(0)/v(1)
			Case "fontTypeFace": fontTypeFace = valx
			Case "headerFontColor": headerFontColor = valx
			Case "elementFontColor": elementFontColor = valx
			Case "screenColor": screenColor = valx
			Case "panelColor": panelColor = valx
			Case "forceAnswers"
				forceAnswers = makeListFrom(valx)
			Case "progressBar"
				progressBar = makeListFrom(valx)
			Case "administrator": administrator = valx
			Case "record": record = valx.toLowerCase
			Case "login": login = valx.toLowerCase
		End Select
	Next
	If progressBar.Size = 2 Then
		progressStart = crossRef.get(progressBar.Get(0))
		progressEnd = crossRef.get(progressBar.Get(1))
	End If
End Sub

Sub slideTimer_Tick()
	If audioPlaying = False Then
		slideStart = DateTime.Now
		Dim audio As Future = MyAudio.GetProp("currentTime")
		Dim p As Float = audio.Value
		If p>0 Then audioPlaying = True
	End If
	If audioPlaying = True Then 
		Dim timeNow As Long = DateTime.now
		Dim timeInto As Long = (timeNow - slideStart)/100
		If slideScheduler.Size = 0 Then Return
		Dim nextSlide As String = slideScheduler.Get(0)
		Dim parts() As String = twoParts(nextSlide, "@")
		Dim mark As Int = parts(1)
		Do While mark < timeInto
			Dim el As JQueryElement = ws.GetElementById(parts(0))
			el.SetCSS("visibility", "visible")
			slideScheduler.RemoveAt(0)
			If slideScheduler.Size = 0 Then Return
			nextSlide  = slideScheduler.Get(0)
			parts = twoParts(nextSlide, "@")
			Dim mark As Int = parts(1)
		Loop
	End If
End Sub

Sub startAudio(sp As String)
	tempName = "QS" & GenerateRandomString(14) & ".mp3"
	Dim v() As String = twoParts(sp," ")
	Dim media As String = v(1).trim & ".mp3"
	File.Copy2(File.OpenInput("QSScripts/" & thisScriptName, media), File.OpenOutput("www/", tempName, False))
	MyAudio.SetProp ("src", "/" & tempName)
	
	slideScheduler.clear
	slideTimer.enabled = True
	slideStart = DateTime.Now
End Sub

Sub startVideo(sp As String)
	MyLogo.SetCSS("visibility", "hidden")
	MainPanel.SetCSS("visibility", "hidden")
	MainDiv.SetCSS("background-color", "transparent")
	MyVideo.SetCSS("visibility", "visible")

	tempName = "QS" & GenerateRandomString(14) & ".mp4"
	Dim v() As String = twoParts(sp," ")
	Dim media As String = v(1).trim & ".mp4"
	File.Copy2(File.OpenInput("QSScripts/" & thisScriptName, media), File.OpenOutput("www/", tempName, False))
	MyVideo.SetProp ("src", "/" & tempName)
	videoPlaying = True
End Sub

Sub disableVideo
	MyVideo.RunMethod ("pause", Null)
	MyVideo.SetProp ("src", "")
	MyVideo.SetCSS("visibility", "hidden")
	MyLogo.SetCSS("visibility", "visible")
	MainPanel.SetCSS("visibility", "visible")
	MainDiv.SetCSS("background-color", screenColor)
	videoPlaying = False
	Sleep(1000)
	Log(tempName & " " & File.delete("www/", tempName))
End Sub

Sub disableAudio
	MyAudio.RunMethod ("pause", Null)
	MyAudio.SetProp ("src", "")
	audioPlaying = False
	Sleep(1000)
	Log(tempName & " " & File.delete("www/", tempName))
End Sub

Sub screenResizeTimer_Tick
	Dim newScreenWidth As Int = MainDiv.GetWidth.value
	Dim newScreenHeight As Int = MainDiv.GetHeight.value
	If newScreenWidth <> screenWidth Or newScreenHeight <> screenHeight Then
		If audioPlaying Then disableAudio
		If videoPlaying Then disableVideo
		screenWidth = newScreenWidth
		screenHeight = newScreenHeight
		setupMainPanel
		Dim logo As Future = MyLogo.GetCSS("visibility")
		If logo.Value <> "hidden" Then
			placeIt (MyLogo, CreateMap("top": xPX(panelHeight/30), "left": xPX((screenWidth - panelWidth)/2 - screenWidth/10)))
			sizeIt (MyLogo, CreateMap("width": xPX(screenWidth/15), "height": xPX(screenWidth/15)))
		End If
		showScreen
	End If
End Sub

Sub makeIt(elType As String, id As String) As String
	Return $"<${elType} id="${id.ToLowerCase}" style="position: absolute; left: 0px; top: 0px; width: 0px; height: 0px"></${elType}>"$
End Sub

Sub placeIt(x As JQueryElement, p As Map)
	For Each a As String In p.Keys
		x.SetCSS(a, p.Get(a))
	Next
End Sub

Sub sizeIt(x As JQueryElement, p As Map)
	For Each a As String In p.Keys
		x.SetCSS(a, p.Get(a))
	Next
End Sub

Sub styleIt(x As JQueryElement, p As Map)
	For Each a As String In p.Keys
		x.SetCSS(a, p.Get(a))
	Next
End Sub

Sub hPX(pt As Float) As String
	Return Round(pt*panelHeight/385) & "px"
End Sub

Sub xPX(pt As Float) As String
	Return Round(pt) & "px"
End Sub

Sub resetLists
	logAnswers.clear
	structureContents.clear
	structureStyle.clear
	For i = 0 To 15
		structureContents.add("<p>&nbsp</p>")
		structureStyle.add("")
	Next
	searchResult.clear
End Sub

Sub copyOf(t As List) As List
	Dim r As List: r.initialize
	For Each s As String In t
		r.Add(s)
	Next
	Return r
End Sub

Private Sub CreateTable
	'create the table if it doesn't already exist
	'QSRecord (SeqNum as Long, User As String, PW As String, Session As Long, TypeUser As String, Complete As String, startDate As String)
	
	Dim columns As Map: columns.Initialize
	columns.Put("SeqNum", DBUtils.DB_INTEGER)
	columns.Put("User", DBUtils.DB_TEXT)
	columns.Put("PW", DBUtils.DB_TEXT)
	columns.Put("Session",  DBUtils.DB_INTEGER)
	columns.Put("TypeUser", DBUtils.DB_TEXT)
	columns.Put("Complete", DBUtils.DB_TEXT)
	columns.Put("Alias", DBUtils.DB_TEXT)
	columns.Put("StartDate", DBUtils.DB_TEXT)
	columns.Put("EndDate", DBUtils.DB_TEXT)
	columns.Put("Content", DBUtils.DB_TEXT)
	DBUtils.CreateTable(SQL1, "QS", columns, "SeqNum")
End Sub

Sub WebSocket_Disconnected
	screenResizeTimer.Enabled = False
	If QSR.Complete = "NO" And record = "yes" Then
		Log("Socket Disconnected " & QSR.TypeUser & " " & dataMap.size)
		If dataMap.Size=0 Then 
			Log("False disconnect???")
		Else
			If QSR.TypeUser="administrator" Or login = "administrator" Then
				QSR.Complete = "YES"
			Else
				dataMap.Put("history", history)
			End If
			If QSR.alias = "" And QSR.user="anon" Then QSR.alias = "anon"
			addNewRecord
		End If
	End If
	ws.Session.Invalidate
End Sub

Sub adminAfterFirstScreen()
	Dim jqx  As JQueryElement = ws.GetElementById("adminlstx")
	Dim answerx As Future = jqx.GetVal
	Dim choice As String = answerx.value
	If choice="All sessions all users" Or choice.startsWith("Activity") Then
		adminRetrieve(choice)
	Else If choice = "---" Then
	Else
		Dim qResult As List = DBUtils.ExecuteMemoryTable(SQL1, _
			"Select SeqNum,User,Complete,StartDate FROM QS WHERE Alias = ? ORDER BY Session", Array As String(choice), 0)
		If qResult.size>0 Then
			Dim sb As StringBuilder: sb.initialize
			sb.Append($"<div>Select session for ${choice}</div>"$)
			Dim st As String = $"vertical-align:top; font-size: ${hPX(9)}; width: ${xPX(panelWidth/2.75)};"$
			sb.Append($"&nbsp &nbsp &nbsp<select id="adminlstz" size="20" style="${st}">"$)
			
			For Each xt() As String In qResult
				Dim suf As String = ""
				If xt(2) = "NO" Then suf = "incomplete "
				If xt(1)<>choice Then suf = suf & "alias"
				Dim opt As String = xt(3) & " " & suf
				sb.Append($"<option value="${xt(0)}" >${opt}</option>"$)
			Next
			sb.Append($"</select>"$)
			st = $"font-size: ${hPX(9)}; background-color: DarkGreen; color: White;"$
			sb.Append($"<p>&nbsp &nbsp &nbsp<button id="adminzrev" style="${st}">REVIEW</button>"$)
			sb.Append($"&nbsp &nbsp &nbsp &nbsp &nbsp &nbsp<button id="adminzdel" style="${st}">DELETE</button></p>"$)
			structureContents.set(1, sb.toString)
			upDateMainPanel
		End If
	End If
End Sub

Sub adminReviewScreen()
	Dim jqx  As JQueryElement = ws.GetElementById("adminlstz")
	Dim answerx As Future = jqx.GetVal
	Dim choice As String = answerx.value
	Dim qResult As List = DBUtils.ExecuteMemoryTable(SQL1, _
			"Select Content,Alias,User,Complete,StartDate FROM QS WHERE SeqNum = ?", Array As String(choice), 1)
	If qResult.size>0 Then
		Dim qs() As String = qResult.Get(0)
		Dim bytes() As Byte = su.DecodeBase64(qs(0))
		Dim thisMap As Map  = ser.ConvertBytesToObject(bytes)
			
		Dim sb As StringBuilder: sb.initialize
		Dim comp As String = ""
		If qs(3) = "NO" Then comp = "incomplete "
		If qs(2)<>qs(1) Then comp = comp & "alias " & qs(2)
		sb.Append($"<p><center>${qs(1)} &zwj; ${qs(4)} ${comp}</center></p>"$)
		Dim st As String = $"font-size: ${hPX(8)}; color: Black"$
		For Each kx As String In thisMap.Keys
			Dim ans As String = thisMap.Get(kx)
			Dim r() As String = twoParts(kx,"#")
			Dim details As String = ""
			If crossRef.ContainsKey(r(0)) Then
				Dim xBlk As Map = scriptSequence.Get(crossRef.Get(r(0)))
				details = xBlk.Get("content")
				If details.StartsWith("<BR>") Then details = details.SubString(4)
				If details.Length>45 Then details = details.SubString2(0,45)
					
				If crossRef.ContainsKey(kx) Then
					Dim v() As String = crossRef.Get(kx)
					details = v(ans) & " @ " & details
				End If
			End If
			sb.Append($"<p style = "${st}">${kx}: [${ans}] ${details}</p>"$)
		Next
		structureContents.set(1, sb.toString)
		upDateMainPanel
	End If
End Sub

Sub adminRetrieve(choice As String)
	Dim startDateRange As String = "1801-010-01 00:00 AM"
	Dim today As Long = DateTime.Now
	If choice = "Activity in past 30 days" Then
		Dim past30 As Long = DateTime.Add(today, 0, 0, -30)
		startDateRange  = DateTime.Date(past30)
	Else if choice = "Activity in past 7 days" Then
		Dim past7 As Long = DateTime.Add(today, 0, 0, -7)
		startDateRange  = DateTime.Date(past7)
	End If
	Dim qResult As List = DBUtils.ExecuteMemoryTable(SQL1, _
		"Select SeqNum,User,TypeUser,Complete,Alias,StartDate,Content FROM QS WHERE EndDate>?", Array As String(startDateRange), 0)

	Dim dictSb As StringBuilder: dictSb.initialize
	Dim fieldNames As List: fieldNames.Initialize
	fieldNames.Add("SeqNum")
	fieldNames.Add("User")
	fieldNames.Add("TypeUser")
	fieldNames.Add("Complete")
	fieldNames.Add("Alias")
	fieldNames.Add("StartDate")

	Dim lastbl As String = ""
	For Each v() As String In qResult
		If v(2)<>"administrator" Then
			Dim bytes() As Byte = su.DecodeBase64(v(v.Length-1))
			Dim thisMap As Map  = ser.ConvertBytesToObject(bytes)
			For Each s As String In thisMap.keys
				If s<>"history" Then
					If fieldNames.IndexOf(s) = -1 Then
						fieldNames.Add(s)
						Dim w() As String = twoParts(s, "#")
						Dim bl As Int = crossRef.Get(w(0))
						Dim theBl As Map = scriptSequence.Get(bl)
						If w(0)<>lastbl Then
							Dim x() As String = Regex.Split("\|", theBl.get("content"))
							If x(0).Length=0 And x.Length>1 Then x(0) = x(1)
							dictSb.Append(w(0) & Chr(9) & x(0) & CRLF)
							lastbl = w(0)
						End If
						Dim elList As List = theBl.Get("elements")
						Dim itemw As Map = elList.get(w(1))
						Dim c As String = itemw.Get("content")
						x = Regex.Split("\|", c)
						If x(0).Length=0 And x.Length>1 Then x(0) = x(1)
						dictSb.Append(s & Chr(9) & x(0) & Chr(9))
						If crossRef.containsKey(s) Then
							Dim v() As String = crossRef.Get(s)
							For i = 0 To v.length-1
								dictSb.Append(i & "=" & v(i) & Chr(9))
							Next
						End If
						dictSb.Remove(dictSb.Length-1,dictSb.Length-1)
						dictSb.Append(CRLF)
						dictSb.Append(CRLF)
					End If
				End If
			Next
		End If
	Next

	Dim dataSb As StringBuilder: dataSb.initialize
	Dim sb As StringBuilder: sb.initialize
	sb.Append($"<div id="retrieve" autofocus style="padding-top: 0px; font-size: ${hPX(5)}; width: 100%; height: 75%; overflow: scroll;">"$)
	sb.Append($"<table style="border: 1px solid Black;">"$)
	sb.append($"<thead style="width: 100%; overflow: hidden;">"$)
	For Each f As String In fieldNames
		If f = "StartDate" Then f  = "______" & f & "______"
		sb.append($"<th style="border: 1px solid Black; padding: 5px;">${f}</th>"$)
		dataSb.append(f & Chr(9))
	Next
	dataSb.Remove(dataSb.Length-1,dataSb.Length-1)
	dataSb.Append(CRLF)
	sb.append("</thead>")
	sb.Append($"<tbody style="border: 1px solid Black; width: 100%; overflow: hidden;">"$)

	Dim dataList As List
	For Each v() As String In qResult
		If v(2)<>"administrator" Then
			dataList.initialize
			For i = 0 To 5
				dataList.Add(v(i))
			Next
			Dim bytes() As Byte = su.DecodeBase64(v(v.Length-1))
			Dim thisMap As Map  = ser.ConvertBytesToObject(bytes)
			For i = 6 To fieldNames.Size-1
				Dim kx As String = fieldNames.get(i)
				Dim s As String = "*"
				If thisMap.ContainsKey(kx) Then s = thisMap.Get(kx)
				dataList.Add(s)
			Next
			sb.append($"<tr>"$)
			For Each f As String In dataList
				sb.append($"<td style="border: 1px solid Black; padding: 5px;">${f}</td>"$)
				dataSb.append(f & Chr(9))
			Next
			dataSb.Remove(dataSb.Length-1,dataSb.Length-1)
			dataSb.Append(CRLF)
			sb.append("</tr>")
		End If
	Next
	dataSb.Remove(dataSb.Length-2,dataSb.Length-1)
	sb.append($"</tbody></table></div>"$)
	structureContents.set(1, sb.toString)
	upDateMainPanel

	placeIt (MyData, CreateMap("top": xPX(panelTop+.78*panelHeight), "left": xPX(panelLeft+.45*panelWidth)))
	placeIt (DoCopy1, CreateMap("top": xPX(panelTop+.78*panelHeight), "left": xPX(panelLeft+(.6*panelWidth/2))))
	sizeIt (DoCopy1, CreateMap("height": xPX(.03*panelHeight), "width": xPX(.4*panelWidth)))
	styleIt (DoCopy1, CreateMap("font-size": hPX(9), "visibility": "visible", "z-index": "1001", "line-height": "0%"))
	MyData.SetCSS("visibility", "visible")
	MyData.SetVal(dataSb.toString)

	placeIt (MyDict, CreateMap("top": xPX(panelTop+.78*panelHeight), "left": xPX(panelLeft+.45*panelWidth)))
	placeIt (DoCopy2, CreateMap("top": xPX(panelTop+.88*panelHeight), "left": xPX(panelLeft+(.6*panelWidth/2))))
	sizeIt (DoCopy2, CreateMap("height": xPX(.03*panelHeight), "width": xPX(.4*panelWidth)))
	styleIt (DoCopy2, CreateMap("font-size": hPX(9), "visibility": "visible", "z-index": "1001", "line-height": "0%"))
	MyDict.SetCSS("visibility", "visible")
	MyDict.SetVal(dictSb.toString)
End Sub

Sub customSearchB4X(target As String) As String
	Dim x() As String = twoParts(target, "-")
	Dim customSearch As String = x(1)
	Dim jqa, jqb, jqt As JQueryElement
	Dim answera, answerb, answert As Future
	Dim leta, letb, lett As String
	
	jqa = ws.GetElementById("lsta"): answera = jqa.GetVal: leta = answera.value
	jqb = ws.GetElementById("lstb"): answerb = jqb.GetVal: letb = answerb.value
	jqt = ws.GetElementById("twolet"): answert = jqt.GetVal: lett = answert.value
	If lett.Length>1 Then
		leta = lett.substring2(0,1)
		letb = lett.substring2(1,2)
	End If
	If leta<>" " And letb<>" " Then
		searchResult = CallSub2("customSubs", customSearch, leta & letb)
		Dim sb As StringBuilder: sb.Initialize
		Dim st As String = $"font-size: ${hPX(9)};"$
		sb.Append($"&nbsp &nbsp &nbsp<select id="lstx" size="30" style="${st}">"$)
		For Each t As List In searchResult
			Dim opt As String = t.Get(0)
			sb.Append($"<option value="${opt}">${opt}</option>"$)
		Next
		sb.Append($"</select>"$)
		st = $"font-size: ${hPX(10)}; background-color: DarkGreen; color: White; position: absolute; top: ${xPX(panelTop + panelHeight/2)};"$
		sb.Append($"&nbsp &nbsp &nbsp<button id="btngo" style="${st}">Go</button>"$)
	End If
	Return sb.ToString
End Sub

Sub goCustomSearch()
	Dim jqx  As JQueryElement = ws.GetElementById("lstx")
	Dim answerx As Future = jqx.GetVal
	Dim choice As String = answerx.value
	For Each t As List In searchResult
		Dim opt As String = t.Get(0)
		If opt = choice Then
			searchChoice = copyOf(t)
			Dim sb As StringBuilder
			sb.Initialize
			Dim st As String = $"font-size: ${hPX(9)};"$
			sb.Append($"&nbsp &nbsp &nbsp<select id="lstz" size="30" onchange="location = this.value" style="${st}">"$)
			For j = 1 To t.Size-1
				Dim xxx As String = t.Get(j)
				Dim b() As String = twoParts(xxx, "@")
				Dim txt As String = b(0)
				Dim rest As String = b(1)
				Dim rx() As String = twoParts(rest, "?")
				If rx(1).Length>0 Then rx(1) = " - " & rx(1)
				Dim url As String = rx(0)
				If rx(0).StartsWith("http") = False Then url = $"https://www.b4x.com/android/help/${rx(0)}.html#${txt}"$
				sb.Append($"<option value="${url}">${txt} &nbsp &nbsp [${rx(0)}${rx(1)}]</option>"$)
			Next
			sb.Append($"</select>"$)
			structureContents.set(1, sb.toString)
			structureStyle.set(1, "")
			upDateMainPanel
		End If
	Next
End Sub

Sub authetication(a As String, thisBlk As Map)
	Dim pars() As String = twoParts(a," ")
	Dim el() As String = twoParts(pars(1), ",")
	Dim userResult As String = fromCrossRef(el(0))
	Dim pwResult As String = fromCrossRef(el(1))
	HashedPassword = HashPassword.HashPW(pwResult)

	Dim qResult As Map = DBUtils.ExecuteMap(SQL1, _
							"SELECT * FROM QS WHERE User=? ORDER BY SeqNum DESC LIMIT 1", Array As String(userResult))
		
	Dim result As String = thisBlk.Get("name") & "#" & crossRef.get(thisBlk.Get("name") & "#RESULT")

	If a.StartsWith("VERIFY") Then
		If qResult.IsInitialized = False Then
			dataMap.Put(result, "invalid")
		Else
			dataMap.Put(result, "valid")
			Dim pwrd As String = qResult.Get("pw")
			If  HashPassword.CheckPW(pwResult, pwrd) Then
				QSR.SeqNum = qResult.Get("seqnum")
				QSR.User = qResult.Get("user")
				QSR.PW = qResult.Get("pw")
				QSR.Session = qResult.Get("session")
				QSR.TypeUser = qResult.Get("typeuser")
				QSR.Complete = qResult.Get("complete")
				QSR.Alias = qResult.Get("alias")
				QSR.StartDate = qResult.Get("startdate")
				QSR.EndDate = qResult.Get("enddate")
				If QSR.Complete = "YES" Then
					QSR.Complete = "NO"
					If QSR.TypeUser = "administrator" Then
						QSR.Complete = "YES"
						isAdministrator = True
					End If
					dataMap.Put(result, "lastcomplete")
					QSR.Session = QSR.Session + 1
					QSR.StartDate = DateTime.Date(DateTime.Now)
					QSR.EndDate = DateTime.Date(DateTime.Now)
					dataMap.Put(result, "valid")
				Else
					QSR.SeqNum = qResult.Get("seqnum")
					QSR.PartialContent = qResult.Get("content")
					dataMap.Put(result, "lastincomplete")
					result = thisBlk.Get("name") & "#" & crossRef.get(thisBlk.Get("name") & "#LASTDATE")
					dataMap.Put(result, QSR.EndDate)
				End If
			Else
				dataMap.Put(result, "invalid")
			End If
		End If
	Else If a.StartsWith("REGISTER") Then
		If qResult.IsInitialized = False Then
			QSR.TypeUser = "client"
			If administrator<>"~none~" And userResult.StartsWith(administrator) Then
				userResult = userResult.SubString(administrator.Length)
				QSR.TypeUser = "administrator"
				isAdministrator = True
			End If
			QSR.User = userResult
			QSR.PW = HashedPassword
			QSR.Session = 1
			QSR.Complete = "NO"
			If QSR.Alias = "" Then QSR.Alias = userResult
			QSR.StartDate = DateTime.Date(DateTime.Now)
			QSR.EndDate = DateTime.Date(DateTime.Now)
		Else
			dataMap.Put(result, "unavailable")
		End If
	End If
End Sub

Sub resetAdmin()
	MyData.setVal("")
	MyData.SetCSS("visibility", "hidden")
	MyDict.setVal("")
	MyDict.SetCSS("visibility", "hidden")
	DoCopy1.SetCSS("visibility", "hidden")
	DoCopy2.SetCSS("visibility", "hidden")
End Sub

Sub recordAnswers()
	Dim currentBlk As Map = scriptSequence.Get(currentBlock)
	Dim bname As String = currentBlk.Get("name")
	For Each f As String In logAnswers
		Dim jq  As JQueryElement = ws.GetElementById(f)
		Dim answer As Future = jq.GetVal
		Dim item As String = f.SubString(4)
		If f.StartsWith("rbtn") Then item = item.SubString2 (0, item.IndexOf("_"))
		Dim a As String = answer.value
		Dim ref As String = $"${bname}#${item}"$
		Dim oldAns As String = ""
		If dataMap.ContainsKey(ref) Then oldAns = dataMap.Get(ref)
		If oldAns = "*" Then a = ""
		If a<>"" Then tobeAnswered = tobeAnswered - 1
		dataMap.Put(ref, a)
	Next
End Sub

Sub renderItem(item As Map, specifier() As String, oldData As String, place As Int, j As Int)
	Dim sp As String = specifier(0)
	Dim pars As String = expandBackRef(specifier(1))

	Dim con As String = ""
	If con.IndexOf("==")>-1 Then con = con.SubString2(0,con.IndexOf("=="))
	If item.ContainsKey("content") Then con = expandBackRef(item.Get("content"))

	Dim style  As String =  deriveStyle(item, 10, "normal", elementFontColor, "")
	If place < j Then place = j + 1 Else	place = place + 1
				
	Dim sb As StringBuilder: sb.initialize
	Select Case sp
		Case ""
			If con<>"&nbsp" Then  sb.Append(html.CheckBox(myPnl, j, con, oldData))
		Case "BLANK"
			sb.Append(html.Subtitle(myPnl, con))
		Case "CHECK"
			sb.Append(html.CheckBox2(myPnl, j, con, oldData))
			tobeAnswered = tobeAnswered + 1
		Case "SUBTITLE"
			sb.Append(html.Subtitle(myPnl, con))
		Case "OPTIONS"
			sb.Append(html.RadioButtonsV(myPnl, j, con, pars, oldData))
			tobeAnswered = tobeAnswered + 1
		Case "LIST"
			sb.Append(html.SelectList(myPnl, j, con, pars, oldData))
			tobeAnswered = tobeAnswered + 1
		Case "TEXT"
			sb.Append(html.Input(myPnl, j, con, "text", oldData, firstTextInput))
			logAnswers.Add($"txtn${j}"$)
			tobeAnswered = tobeAnswered + 1
		Case "USER"
			sb.Append(html.Input(myPnl, j, con, "text", oldData, firstTextInput))
			logAnswers.Add($"txtn${j}"$)
			tobeAnswered = tobeAnswered + 1
		Case "PASSWORD"
			sb.Append(html.Input(myPnl, j, con, "password", oldData, firstTextInput))
			logAnswers.Add($"txtn${j}"$)
			tobeAnswered = tobeAnswered + 1
		Case "EMAIL"
			sb.Append(html.Input(myPnl, j, con, "email", oldData, firstTextInput))
			logAnswers.Add($"txtn${j}"$)
			tobeAnswered = tobeAnswered + 1
		Case "INFO"
			sb.Append(html.Info(myPnl, con))
		Case "LINK"
			place = fromPosition(item, place)
			If place>9999 Then
				con = "<center>" & con & "</center>"
				place = place - 10000
			End If
			sb.Append(html.Link(myPnl, con, pars))
		Case "SEARCH"
			sb.Append(html.Search(myPnl, j, con, pars))
		Case "ADMIN"
			Dim qResult As List = DBUtils.ExecuteMemoryTable(SQL1, _
				"SELECT SeqNum,Alias,typeUser FROM QS ORDER BY Alias,SeqNum", Null, 0)
			sb.Append(html.Admin(myPnl, j, pars, qResult))
		Case "CLICK"
			place = fromPosition(item, place)
			If place>9999 Then
				con = "<center>" & con & "</center>"
				place = place - 10000
			End If
			sb.Append(con)
		Case "STARTAT"
			Dim hide As String = ""
			If j>0 Then hide  = "hidden"
			Dim marker As String = $"item${j}@${pars}"$
			style  =  deriveStyle(item, 13, "bold", "Black", hide)
			If con.StartsWith("*") Then
				style  =  deriveStyle(item, 10, "normal", "Blue", "hidden")
				con = "&nbsp &nbsp &nbsp &nbsp &#9679 &nbsp &nbsp" & con.SubString(1)
				sb.Append(html.Bullet(myPnl, con))
			Else
				sb.Append(html.Subtitle(myPnl, con))
			End If
			slideScheduler.Add(marker)
		Case "SCALE"
			sb.Append(html.RadioButtonsH(myPnl, j, con, pars, oldData, "SCALE"))
			tobeAnswered = tobeAnswered + 1
	End Select
	structureContents.set(place, sb.toString)
	structureStyle.set(place, style)
	If place>MaxN Then MaxN = place
End Sub

Sub addNewRecord
	Dim m As Map: m.Initialize
	m.Put("User", QSR.User)
	m.Put("PW", QSR.PW)
	m.Put("Session", QSR.Session)
	m.Put("TypeUser", QSR.TypeUser)
	m.Put("Complete", QSR.Complete )
	m.Put("Alias", QSR.Alias )
	m.Put("StartDate", QSR.StartDate)
	m.Put("EndDate", DateTime.Date(DateTime.Now))
	Dim bytes() As Byte = ser.ConvertObjectToBytes(dataMap)
	Dim s As String  = su.EncodeBase64(bytes)
	m.Put("Content", s)
	DBUtils.InsertMaps(SQL1, "QS", Array As Object(m))
End Sub

Sub GenerateRandomString (Length As Int) As Long
	Dim su As StringUtils
	Dim bytes(Length) As Byte
	SecureRandom1.GetRandomBytes(bytes)
	Dim bc As ByteConverter
	Dim v() As Long = bc.LongsFromBytes(bytes)
	If v(0)<0 Then v(0) = -v(0)
	Return v(0)
End Sub