﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.01
@EndOfDesignText@
Sub Process_Globals
	Public origScript As List
End Sub

Sub recreateJson(thisScriptName As String, isDebug As Boolean)
	Dim scriptDir As String = "QSScripts/" & thisScriptName
	If isDebug Or File.Exists(scriptDir, thisScriptName & ".json") = False Then
		If File.Exists(scriptDir, thisScriptName & ".txt") = True Then
			Dim sequence As List
			sequence.Initialize
			origScript = File.ReadList (scriptDir, thisScriptName & ".txt")
			parseOrigScript(sequence)
			Dim jsonList As List = generateScriptFile (sequence)
			File.WriteList (scriptDir, thisScriptName & ".json", jsonList)
		Else
			Dim out As OutputStream = File.OpenOutput(scriptDir, thisScriptName & ".json", False)
			File.WriteString (scriptDir, thisScriptName & ".json", $"{"sequence" : []}"$)
			out.close
		End If
	End If
End Sub

Sub generateScriptFile (sequence As List) As List
	Dim r As List: r.initialize
	
	Dim nEl As Int = sequence.Size - 1
	r.add ($"{"sequence" : ["$)
	For inx = 0 To nEl
		Dim testBlock As List = sequence.Get(inx)
	
		Dim el As Element
		For j = 0 To testBlock.Size-1	
			el = testBlock.get(j)
			Dim t As StringBuilder: t.Initialize
			If j=0 Then
				If el.position.Length=0 Then el.position = "center,*"
				t.Append("   {")
			Else
				t.Append("         {")
			End If

			If el.name.Length>0 Then t.append ($""name" : "${el.name}" , "$)
			If el.content.Length>0 Then t.append ($""content" : "${el.content}" , "$)
			If el.specifier.Length>0 Then t.append ($""specifier" : "${el.specifier}" , "$)
			If el.condition.Length>0 Then t.append ($""condition" : "${el.condition}" , "$)
			If el.position.Length>0 Then t.append ($""position" : "${el.position}" , "$)
			If el.style.Length>0 Then t.append ($""style" : "${el.style}" , "$)
			If el.comment.Length>0 Then t.append ($""comment" : "${el.comment}" , "$)
			If el.scriptOptions.Length>0 Then
				Dim d() As String = twoParts(el.scriptOptions, "=")
				If d(1).Length = 0 Then d(1) = "*"
				t.append ($""${d(0).trim}" : "${d(1).trim}" , "$)
			End If
			If el.actions.Size>0 Then
				t.append ($""actions" : ["$)
				For jj = 0 To el.actions.Size-1
					t.append ($""${el.actions.get(jj)}" , "$)
				Next
				t.Remove(t.Length-3,t.Length)
				t.append("]")
			Else
				t.Remove(t.Length-2,t.Length)
			End If
			
			If j=0 Then
				t.Append($", "elements" : ["$)
			Else
				t.Append("} , ")
				If j = testBlock.Size-1 Then
					t.Remove (t.Length-2, t.Length)
				End If
			End If

			Dim g As String = t.ToString
			r.add(g)
		Next

		If inx < nEl-1 Then
			r.add ("   ]} , ")
			r.add (" ")
		Else If inx=nEl-1 Then
			r.add ("   ]}")
		End If
	Next
	r.add ("]}")
	Return r
End Sub

Sub rightTrim(s As String) As String
	Dim k As  Int = -1
	For i = s.Length - 1 To 0 Step -1
		If s.CharAt(i)<>" " Then 
			k = i + 1
			Exit
		End If
	Next
	If k>-1 Then 
		s = s.SubString2(0, k)
	Else 
		s=""
	End If
	Return s
End Sub

Sub parseOrigScript(sequence As List)
	Dim skip As Boolean = False
	Dim condensed As List: condensed.initialize
	Dim temp As String = ""
	Dim prev As String = "*"

	Dim expanded As List: expanded.initialize
	For i = 0 To origScript.Size - 1
		Dim s As String = rightTrim(origScript.Get(i))
		If s.StartsWith("#include") Then
			Dim v() As String = twoParts(s, " ")
			expanded.Add("")
			Dim addScript As String = "QSScripts/" & "commonScripts"
			Dim newScript As List = File.ReadList (addScript, v(1).trim & ".txt")
			For Each t As String In newScript
				expanded.Add(t)
			Next
			expanded.Add("")
		Else
			expanded.Add(s)
		End If
	Next
	
	For i = 0 To expanded.Size - 1
		Dim s As String = rightTrim(expanded.Get(i))
		If s = "/*" Then
			skip = True
		else If s = "*/" Then
			skip = False
		else if skip = False Then
			If s.IndexOf("<STARTAT") > -1 Then
				s = Regex.Replace(Chr(9), s, "*")
			End If
			If s.StartsWith(" ") Or s.StartsWith(Chr(9)) Then
				s = Regex.Replace(Chr(9), s, "")
				If temp.indexOf("<OPTIONS ")>-1 Then
					temp = temp & "|" & s.trim
				Else if temp.indexOf("<OPTIONS")>-1  Then
					temp = temp & " " & s.trim
				Else
					temp = temp & " " & s.trim
				End If
			Else
				If condensed.Size>0 Then prev = condensed.Get(condensed.Size-1)
				If temp.Length>0 Or prev.length>0 Then
					condensed.Add(temp)
				End If
				temp = s
			End If
		End If
	Next
	condensed.RemoveAt(0)
	condensed.Add(temp)
	
	Dim lastOne As String = condensed.Get(condensed.Size-1)
	Do While lastOne.trim = ""
		condensed.RemoveAt(condensed.Size-1)
		If condensed.Size=0 Then Exit
		lastOne = condensed.Get(condensed.Size-1)
	Loop
	condensed.Add("")
	
	Dim blocks As List: blocks.Initialize
	Dim block As List: block.initialize
	blocks.Add(block)
	
	For i = 0 To condensed.Size - 1
		Dim s As String = condensed.Get(i)
		If s.Length = 0 Then
			Dim newBlock As List: newBlock.initialize
			blocks.Add(newBlock)
			block = newBlock
		Else
			block.add(s)
		End If
	Next
	
	For Each thisBlock As List In blocks
		Dim parsedBlock As List: parsedBlock.initialize
		For Each s As String In thisBlock
			parsedBlock.Add (parseElement(s))
		Next
		sequence.add(parsedBlock)
	Next
	
End Sub

Sub parseElement(s As String) As Element
	Dim thisE As Element: thisE.initialize
	thisE.actions.Initialize
	thisE.errors.Initialize

	If s.startsWith("//") Then
		thisE.comment = changeQuotes(s.SubString(2).Trim)
		Return thisE
	End If

	If s.startsWith("{") Then
		s = s.trim
		s = s.SubString2(1, s.Length-1)
		thisE.scriptOptions = changeQuotes(s)
		Return thisE
	End If

	If s.IndexOf("^") > -1 Then
		Dim w() As String = twoParts(s, "^")
		If w(0).StartsWith("(") Then
			Dim h() As String = twoParts(s, ")")
			w(0) = h(0).SubString(1)
		End If
		thisE.position = w(0)
		s = w(1)
	End If

	If s.IndexOf("{") > -1 Then
		Dim w() As String = twoParts(s, "}")
		If w(0).StartsWith("IF") And w(1).Length>0 Then
			Dim bracket As Int = w(0).IndexOf("{")
			thisE.condition = w(0).SubString(bracket+1).trim
			s = w(1).trim
		End If
	End If


	If s.IndexOf(":") > -1 Then
		Dim w() As String = twoParts(s, ":")
		Dim isName As Boolean = True
		For i = 0 To w(0).Length-1
			Dim c As Char = w(0).CharAt(i)
			If "ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890".IndexOf(c) = -1 Then
				isName = False
				Exit
			End If
		Next
		If isName Then
			thisE.name = w(0)
			s = w(1)
		End If
	End If

	If s.IndexOf(">") > -1 Then
		Dim w() As String = twoParts(s, ">")
		Dim h() As String = twoParts(w(1), ">")
		thisE.actions.add(h(0).trim)
		Do While h(1).Length>0
			h = twoParts(h(1), ">")
			thisE.actions.add(h(0).trim)
		Loop
		s = w(0)
	End If

	If s.IndexOf("<") > -1 Then
		Dim w() As String = twoParts(s, "<")
		If w(1).IndexOf("<")>-1 Then
			thisE.errors.add ("too many '<'")
		Else
			thisE.specifier = w(1).trim
			s = w(0)
		End If
	End If

	If s.Length = 0 And thisE.specifier = "" And thisE.actions.size>0  Then
		thisE.specifier = "ACTIONONLY"
	End If

	If s.IndexOf("\") > -1 Then
		Dim w() As String = twoParts(s, "\")
		If w(1).IndexOf("\")>-1 Then
			thisE.errors.add ("too many '\'")
		Else
			thisE.style = w(1).trim
			s = w(0)
		End If
	End If
	
	s = s.trim
	If s.startsWith("+") Then
		thisE.position = "center,*"
		s = s.SubString(1)
		If s="" Then 
			s = "&nbsp"
			thisE.specifier = "BLANK"
		Else
			thisE.specifier = "SUBTITLE"
		End If
	End If
		
	If s.startsWith(".") Then
		thisE.style = ("RIGHTCOLUMN " & thisE.style).trim
		s = s.SubString(1)
	End If
	
	If s.startsWith("_") Then
		s = s.SubString(1)
		Dim ks As Int = s.IndexOf("_")
		Dim st As String = s.SubString2(0, ks)
		s = s.SubString(ks+1)
		thisE.style = (thisE.style & " " & st)
	End If

	If s.StartsWith("!") Then
		thisE.position = "left,*"
		s=s.SubString (1)
	End If
	If s.IndexOf("|") >-1 Then s = paragraphs(s)
	thisE.content = changeQuotes(s.trim)
	Return thisE
End Sub

Sub paragraphs(s As String) As String
	Dim v() As String = Regex.Split("\|", s)
	Dim sb As StringBuilder: sb.initialize
	For Each w As String In v
		sb.Append($"${w}<BR>"$)
	Next
	If sb.length>0 Then sb.Remove(sb.Length-4, sb.Length)
	Return sb.toString
End Sub

Sub twoParts(s As String, c As String) As String()
	Dim r(2) As String
	r(0) = s
	r(1) = ""
	Dim k As Int = s.indexOf(c)
	If k>-1 Then
		r(0) = s.SubString2(0, k)
		r(1) = s.SubString(k+1)
	End If
	Return r
End Sub

Sub changeQuotes(Raw As String) As String
	Dim sb As StringBuilder: sb.Initialize
	For i = 0 To Raw.Length - 1
		Dim C As Char = Raw.CharAt(i)
		Select C
			Case QUOTE
				sb.Append($"\""$)
			Case Else
				sb.Append(C)
		End Select
	Next
	Return sb.ToString
End Sub


Sub defineShowable() As Map
	Dim isShowable As Map
	isShowable.initialize
	isShowable.Put("ADDTO", False)
	isShowable.Put("ACTIONONLY", False)
	isShowable.Put("BUTTON", False)
	isShowable.Put("LOGO", False)
	
	isShowable.Put("BLANK", True)
	isShowable.Put("", True)
	isShowable.Put("CHECK", True)
	isShowable.Put("OPTIONS", True)
	isShowable.Put("LIST", True)
	isShowable.Put("CLICK", True)
	isShowable.Put("NAME", True)
	isShowable.Put("PHONE", True)
	isShowable.Put("NAME", True)
	isShowable.Put("EMAIL", True)
	isShowable.Put("USER", True)
	isShowable.Put("PASSWORD", True)
	isShowable.Put("DATE", True)
	isShowable.Put("LINK", True)
	isShowable.Put("MONEY", True)
	isShowable.Put("ADDRESS", True)
	isShowable.Put("CAPS", True)
	isShowable.Put("SIN", True)
	isShowable.Put("POSTAL", True)
	isShowable.Put("TEXT", True)
	isShowable.Put("SCALE", True)
	isShowable.Put("SLIDER", True)

	isShowable.Put("INFO", True)
	isShowable.Put("COMMENT", True)
	isShowable.Put("RICHTEXT", True)
	isShowable.Put("SEARCH", True)
	isShowable.Put("ADMIN", True)
	isShowable.Put("REPORT", True)
	isShowable.Put("GRID", True)
	isShowable.Put("CELL", True)
	isShowable.Put("TRIGGER", True)
	
	isShowable.Put("AUDIO", True)
	isShowable.Put("VIDEO", True)
	isShowable.Put("SLIDEHOW", True)
	isShowable.Put("STARTAT", True)
	
	isShowable.Put("TITLE", True)
	isShowable.Put("SUBTITLE", True)
	Return isShowable
End Sub

